Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/JFCProgressionChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/JFCProgressionChartCreator.java	(revision 0)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/JFCProgressionChartCreator.java	(revision 137)
@@ -0,0 +1,327 @@
+package org.txm.progression.core.chartsengine.jfreechart;
+
+import java.awt.BasicStroke;
+import java.awt.Color;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.jfree.chart.JFreeChart;
+import org.jfree.chart.axis.NumberAxis;
+import org.jfree.chart.plot.Marker;
+import org.jfree.chart.plot.ValueMarker;
+import org.jfree.data.xy.XYDataset;
+import org.jfree.data.xy.XYSeries;
+import org.jfree.data.xy.XYSeriesCollection;
+import org.jfree.ui.RectangleAnchor;
+import org.jfree.ui.TextAnchor;
+import org.txm.chartsengine.core.ChartsEngine;
+import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
+import org.txm.chartsengine.jfreechart.core.renderers.MultipleItemsSelector;
+import org.txm.chartsengine.jfreechart.core.renderers.interfaces.IItemSelectionRenderer;
+import org.txm.chartsengine.jfreechart.core.themes.base.ExtendedNumberAxis;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.progression.core.chartsengine.base.ProgressionChartCreator;
+import org.txm.progression.core.chartsengine.base.Utils;
+import org.txm.progression.core.chartsengine.jfreechart.themes.highcharts.renderers.ProgressionItemSelectionRenderer;
+import org.txm.progression.core.functions.Progression;
+import org.txm.progression.core.messages.ProgressionCoreMessages;
+import org.txm.progression.core.preferences.ProgressionPreferences;
+import org.txm.searchengine.cqp.corpus.query.Query;
+
+/**
+ * JFC progression chart creator.
+ * 
+ * @author sjacquot
+ *
+ */
+public class JFCProgressionChartCreator extends JFCChartCreator implements ProgressionChartCreator {
+
+	public JFCProgressionChartCreator() {
+		// TODO Auto-generated constructor stub
+	}
+
+	@Override
+	public JFreeChart createChart(Object resultData, String preferencesNode) {
+
+		
+		Progression progression = (Progression) resultData;
+		
+		// parameters
+//		boolean monochrome = (TXMPreferences.getInt(preferencesNode, resultData, ChartsEnginePreferences.RENDERING_COLORS_MODE, ChartsEnginePreferences.PREFERENCES_NODE)
+//				== ChartsEngine.RENDERING_MONOCHROME_MODE);
+		boolean monostyle = TXMPreferences.getBoolean(preferencesNode, resultData, ProgressionPreferences.CHART_MONO_STYLE);
+		boolean cumulative = TXMPreferences.getBoolean(preferencesNode, resultData, ProgressionPreferences.CHART_CUMULATIVE);
+		
+		
+		JFreeChart chart = null;
+
+		// Create the dataset
+		XYSeriesCollection dataset = new XYSeriesCollection();
+		List<int[]> positions = progression.getAllpositions();
+		List<Query> queries = progression.getQueries();
+		// Y axis label
+		String yAxisLabel;
+
+		// Cumulative
+		if(cumulative)	{
+			for(int i = 0; i < progression.getAllpositions().size(); i++) {
+				int[] list = positions.get(i);
+				Query query = queries.get(i);
+				XYSeries series = new XYSeries(query.toString() + " " + list.length);
+				int c = 1;
+				for(int j = 0; j < list.length; j++) {
+					// Add a first point to draw a vertical line
+					if(j == 0)	{
+						series.add(list[j], 0);
+					}
+					series.add(list[j], c++);
+				}
+
+				// FIXME: add a dummy point to draw horizontal line between last point and max X corpus
+				series.add(progression.getXmaxCorpus(), --c);
+				dataset.addSeries(series);
+			}
+
+			// Create the chart
+			yAxisLabel = ProgressionCoreMessages.ChartsEngine_PROGRESSION_Y_AXIS_CUMULATIVE_LABEL;
+			chart = this.getChartsEngine().createXYStepChart(dataset, Utils.createProgressionChartTitle(progression, cumulative),
+					ProgressionCoreMessages.bind(ProgressionCoreMessages.ChartsEngine_PROGRESSION_X_AXIS_LABEL, progression.getXmaxCorpus()), yAxisLabel, true, true, true, true, true);
+
+
+			// Custom renderer
+			chart.getXYPlot().setRenderer(new ProgressionItemSelectionRenderer());
+
+		}
+		// FIXME : Density, to implement when textometry R package will store the result in the Progression class
+		else	{
+
+			// FIXME : density not yet implemented
+			System.err.println("JFCChartsEngine.createProgressionChart(): density mode not yet implemented.");
+
+			for(int i = 0; i < progression.getAllpositions().size(); i++) {
+				int[] liste = positions.get(i);
+				Query query = queries.get(i);
+				XYSeries series = new XYSeries(query.toString() + " " + liste.length);
+
+				for(int j = 0; j <  liste.length; j++) {
+
+					// FIXME : tests y
+					// y <- c( c(0), y , c(y[[length(x)]]) ) // R code
+					// FIXME : random Y value
+					double y = progression.getAllpositions().get(i)[j] * Math.random();
+	//				double y = progression.getAllpositions().get(i)[j];
+					series.add(liste[j], y);
+				}
+				dataset.addSeries(series);
+			}
+
+			// Create the chart
+			yAxisLabel =  ProgressionCoreMessages.ChartsEngine_PROGRESSION_Y_AXIS_NOT_CUMULATIVE_LABEL;
+			chart = this.getChartsEngine().createXYLineChart(dataset, Utils.createProgressionChartTitle(progression, cumulative),
+					ProgressionCoreMessages.bind(ProgressionCoreMessages.ChartsEngine_PROGRESSION_X_AXIS_LABEL, progression.getXmaxCorpus()), yAxisLabel,
+					true, true, true, false, true, false, true, null);
+		}
+
+
+
+        ((IItemSelectionRenderer) chart.getXYPlot().getRenderer()).setChartType(ChartsEngine.CHART_TYPE_PROGRESSION);
+        ((IItemSelectionRenderer) chart.getXYPlot().getRenderer()).getItemsSelector().setResultData(progression);
+
+
+		// Add the limit markers
+		BasicStroke dashedStroke = new BasicStroke(0.5f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 1f, new float[] {2f}, 0f);
+		Marker marker = new ValueMarker(progression.getXminCorpus());
+        marker.setPaint(Color.gray);
+        marker.setStroke(dashedStroke);
+        chart.getXYPlot().addDomainMarker(marker);
+		marker = new ValueMarker(progression.getXmaxCorpus());
+        marker.setPaint(Color.gray);
+        marker.setStroke(dashedStroke);
+        chart.getXYPlot().addDomainMarker(marker);
+
+
+//        // FIXME : limit with annotations rather than markers (marker height is dynamically adapted to the real chart height.
+        // Annotation have a fixed height)
+//        XYLineAnnotation annotation = new XYLineAnnotation(0, 0, 0, dataset.getRangeUpperBound(true), dashedStroke, Color.gray);
+//        chart.getXYPlot().addAnnotation(annotation, true);
+
+		// Add the part markers
+		if(progression.getStructurePositions().length > 0)	{
+			for(int i = 0; i < progression.getStructurePositions().length; i++) {
+				if(progression.getStructurePositions()[i] != 0)	{
+					marker = new ValueMarker(progression.getStructurePositions()[i]);
+			        marker.setPaint(Color.black);
+			        marker.setLabel(progression.getStructureNames()[i]);
+			        marker.setLabelAnchor(RectangleAnchor.TOP_RIGHT);
+			        marker.setLabelTextAnchor(TextAnchor.HALF_ASCENT_LEFT);
+
+
+			        // FIXME: test of rotated annotations rather than using marker label. The problem with this is that the position of annotation is not adjusted when zooming/dezooming.
+			        // FIXME: the best approach is to redefine the drawing method of
+////			        double start = marker.getStartValue();
+////			        double end = TempIntervalMarker.getEndValue();
+////			        double middle = (end - start)/2;
+//			        XYTextAnnotation updateLabel = new XYTextAnnotation("Update", progression.getStructurePositions()[i], 0);
+//			        updateLabel.setFont(new Font("Sans Serif", Font.BOLD, 10));
+//			        updateLabel.setRotationAnchor(TextAnchor.BASELINE_CENTER);
+//			        updateLabel.setTextAnchor(TextAnchor.BASELINE_CENTER);
+//			        updateLabel.setRotationAngle(3.14 / 2);
+//			        updateLabel.setPaint(Color.black);
+//			        chart.getXYPlot().addAnnotation(updateLabel);
+
+
+
+			        chart.getXYPlot().addDomainMarker(marker);
+				}
+			}
+		}
+
+		// Custom domain axis for ticks drawing options
+		chart.getXYPlot().setDomainAxis(new ExtendedNumberAxis((NumberAxis) chart.getXYPlot().getDomainAxis(), true, true, progression.getXminCorpus(), progression.getXmaxCorpus()));
+
+		// Custom range axis for ticks drawing options
+		chart.getXYPlot().setRangeAxis(new ExtendedNumberAxis((NumberAxis) chart.getXYPlot().getRangeAxis(), false, true, 0, progression.getMaxY()));
+
+		// Match the X-axis origin value to the min x corpus (for subcorpus case)
+		chart.getXYPlot().getDomainAxis().setLowerBound(progression.getXminCorpus());
+
+
+//        int itemsColorsRenderingMode = Theme.ITEMS_RENDERING_COLORS_MODE;
+//		// Grayscale
+//        if(grayscale)	{
+//        	itemsColorsRenderingMode = Theme.ITEMS_RENDERING_GRAYSCALE_MODE;
+//        }
+
+        // Re-apply theme to the chart to match the colors rendering mode
+        // FIXME : the rendering mode should be pass to all methods, even base methods as createXYLineChart(), createBarChart(), etc.
+        // or better, to be stocked into a member variable in the theme ?
+      //  this.getChartsEngine().getTheme().applyThemeToChart(chart, TXMPreferences.getInt(ProgressionPreferences.PREFERENCES_NODE, resultData, ChartsEnginePreferences.RENDERING_COLORS_MODE, ChartsEnginePreferences.PREFERENCES_NODE), monostyle);
+
+		// synchronizes the chart with the shared preferences 
+		//super.syncChart(chart, resultData, ProgressionPreferences.PREFERENCES_NODE);
+		
+		return chart;
+		
+	}
+
+
+	
+
+	@Override
+	public ArrayList<Integer> getSelectedPointPositions(Object chart) {
+
+		MultipleItemsSelector selector = (MultipleItemsSelector) ((IItemSelectionRenderer)((JFreeChart) chart).getXYPlot().getRenderer()).getItemsSelector();
+		ArrayList<Integer> pointPositionsInCorpora = new ArrayList<Integer>();
+
+
+		// FIXME: returns all the point positions
+		XYDataset dataset = ((JFreeChart) chart).getXYPlot().getDataset();
+		for(int i = 0; i < selector.getSelectedSeries().length; i++) {
+			int selectedSeries = selector.getSelectedSeries()[i];
+			int[] selectedItemsInSeries = selector.getSelectedItems(selectedSeries) ;
+			for(int j = 0; j < selectedItemsInSeries.length; j++) {
+				// if it's the dummy last chart point, get the previous point position instead of ther last one
+				if(selectedItemsInSeries[j] == dataset.getItemCount(selectedSeries) - 1)	{
+					pointPositionsInCorpora.add((int) (dataset.getXValue(selectedSeries, selectedItemsInSeries[j] - 1)));
+				}
+				else	{
+					pointPositionsInCorpora.add((int) (dataset.getXValue(selectedSeries, selectedItemsInSeries[j])));
+				}
+			}
+			
+		}
+
+		// put the last selected point at the end of the list
+		if(selector.getLastSelectedSeries() != -1 && selector.getLastSelectedItem() != -1)	{
+			int item = selector.getLastSelectedItem();
+			// if it's the dummy last chart point, get the previous point position instead of ther last one
+			if(item == dataset.getItemCount(selector.getLastSelectedSeries()) - 1)	{
+				item--;
+			}
+			
+			Integer lastSelectedPointPosition = (int) (dataset.getXValue(selector.getLastSelectedSeries(), item));
+			pointPositionsInCorpora.remove(lastSelectedPointPosition);
+			pointPositionsInCorpora.add(lastSelectedPointPosition);
+		}
+		return pointPositionsInCorpora;
+	}
+
+	@Override
+	public ArrayList<Integer> getSelectedPointNumbers(Object chart) {
+
+		MultipleItemsSelector selector = (MultipleItemsSelector) ((IItemSelectionRenderer)((JFreeChart) chart).getXYPlot().getRenderer()).getItemsSelector();
+		ArrayList<Integer> pointNumbers = new ArrayList<Integer>();
+		XYDataset dataset = ((JFreeChart) chart).getXYPlot().getDataset();
+		
+		for(int i = 0; i < selector.getSelectedSeriesCount(); i++) {
+			int series = selector.getSelectedSeries()[i];
+			int[] items = selector.getSelectedItems(series);
+			int lastDummyItem = dataset.getItemCount(series) - 1; 
+			for(int j = 0; j < items.length; j++) {
+				int item = items[j];
+				// manage the first dummy point
+				if(item == 0)	{
+					item++;
+				}
+				// manage the last dummy point
+				else if(item == lastDummyItem)	 {
+					item--;
+				}
+				
+				pointNumbers.add(item);
+			}
+		}
+		
+		return pointNumbers;
+	}
+	
+
+	
+	@Override
+	public ArrayList<ArrayList<Integer>> getAllPointPositionsBySeries(Object chart) {
+
+		ArrayList<ArrayList<Integer>> pointPositionsBySeries = new ArrayList<ArrayList<Integer>>();
+		
+		XYDataset dataset = ((JFreeChart) chart).getXYPlot().getDataset();
+
+		for(int i = 0; i < dataset.getSeriesCount(); i++) {
+			ArrayList<Integer> pointPositionsInCorpora = new ArrayList<Integer>();
+			for(int j = 0; j < dataset.getItemCount(i) - 1; j++) { // -1 to skip the last dummy point of the step chart
+				pointPositionsInCorpora.add((int) dataset.getXValue(i, j));
+			}
+			pointPositionsBySeries.add(pointPositionsInCorpora);
+		}
+
+		return pointPositionsBySeries;
+	}
+
+	
+	
+	@Override
+	public ArrayList<Integer> getSelectedSeries(Object chart) {
+		ArrayList<Integer> selectedSeries = new ArrayList<Integer>();
+		MultipleItemsSelector selector = (MultipleItemsSelector) ((IItemSelectionRenderer)((JFreeChart) chart).getXYPlot().getRenderer()).getItemsSelector();
+		Integer[] multipleSelectedSeries = selector.getSelectedSeries();
+		for(int i = 0; i < multipleSelectedSeries.length; i++) {
+			selectedSeries.add(multipleSelectedSeries[i]);
+		}
+		return selectedSeries;
+	}
+
+
+	@Override
+	public int getLastSelectedSeries(Object chart) {
+		return ((MultipleItemsSelector) ((IItemSelectionRenderer)((JFreeChart) chart).getXYPlot().getRenderer()).getItemsSelector()).getLastSelectedSeries();
+	}
+
+	
+	
+	@Override
+	public Class getResultDataClass() {
+		return Progression.class;
+	}
+
+
+	
+
+}

Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/themes/highcharts/renderers/ProgressionItemSelectionRenderer.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/themes/highcharts/renderers/ProgressionItemSelectionRenderer.java	(revision 136)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/themes/highcharts/renderers/ProgressionItemSelectionRenderer.java	(revision 137)
@@ -14,7 +14,7 @@
 import org.txm.chartsengine.jfreechart.core.renderers.interfaces.IItemSelectionRenderer;
 import org.txm.chartsengine.jfreechart.core.themes.highcharts.defaulttheme.renderers.ItemSelectionXYStepRenderer;
 import org.txm.chartsengine.jfreechart.core.themes.highcharts.defaulttheme.swing.CustomHTMLToolTip;
-import org.txm.progression.core.functions.Progression2;
+import org.txm.progression.core.functions.Progression;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.query.Match;
@@ -67,7 +67,7 @@
 //
 //				// FIXME: test affichage des concordances des occurrences directement dans le tooltip
 //				// Progression
-				String concordanceStr = "";
+//				String concordanceStr = "";
 
 //				if(renderer.getChartType() == ChartsEngine.CHART_TYPE_PROGRESSION)	{
 //					try {
@@ -251,10 +251,10 @@
 			Property prop;
 			
 			// Ref
-			prop = ((Progression2)this.multipleItemsSelector.getResultData()).getCorpus().getProperty("ref"); //$NON-NLS-1$
+			prop = ((Progression)this.multipleItemsSelector.getResultData()).getCorpus().getProperty("ref"); //$NON-NLS-1$
 			// Text id
 			if(prop == null)	{
-				prop = ((Progression2)this.multipleItemsSelector.getResultData()).getCorpus().getStructuralUnit("text").getProperty("id"); //$NON-NLS-1$ //$NON-NLS-2$
+				prop = ((Progression)this.multipleItemsSelector.getResultData()).getCorpus().getStructuralUnit("text").getProperty("id"); //$NON-NLS-1$ //$NON-NLS-2$
 			}
 			
 			Match selectedWordMatch = new Match(globalPosition, globalPosition);
Index: tmp/org.txm.progression.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.progression.core/META-INF/MANIFEST.MF	(revision 136)
+++ tmp/org.txm.progression.core/META-INF/MANIFEST.MF	(revision 137)
@@ -10,7 +10,7 @@
  org.txm.chartsengine.jfreechart.core;bundle-version="1.0.0",
  org.txm.chartsengine.r.core;bundle-version="1.0.0"
 Export-Package: org.txm.progression.core.chartsengine.base,
- org.txm.progression.core.chartsengine.jfreechart.themes.highcharts,
+ org.txm.progression.core.chartsengine.jfreechart,
  org.txm.progression.core.chartsengine.jfreechart.themes.highcharts.renderers,
  org.txm.progression.core.chartsengine.r,
  org.txm.progression.core.functions,
